using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.IO;
using System.Collections;
using System.Text.RegularExpressions;

namespace UUN
{
    /// <summary>
    /// 编译Search_Music.aspx文件
    /// </summary>
    public class 编译扩展_Search_Music : 编译扩展接口
    {
        private SqlConnection 连接;
        private HttpContext HC;
        private 编译器 编译器;

        public 编译扩展_Search_Music(SqlConnection 连接, HttpContext HC, 编译器 编译器)
        {
            this.连接 = 连接;
            this.HC = HC;
            this.编译器 = 编译器;
        }

        private int 一页显示记录数 = 0;
        public String 开始执行代码()
        {
            编译器.方法库 += @"	private String 当前页面=@""" + 编译器.文件名称.Replace("\"", "\"\"") + @""";
	//参数
	private String 所属栏目;
	private String 关键字;
	//其它
	private String 跳页表单项;
	private String _3G跳页表单项;
	private String 查询条件="""";
	private String 栏目名称;
	//列表分页
	private int 当前页;
	private int 总页数;
	private int 总记录数;
	private int 一页显示记录数;
	private String 列表跳页(int 页码)
	{
		return Server.HtmlEncode(常用.处理地址(当前页面+""?ID=""+
			Server.UrlEncode(所属栏目)+
			""&g=""+Server.UrlEncode(关键字)+
			""&page=""+页码,访问.用户[""标识""].ToString()));
	}
	private String 获取栏目名称()
	{
		String 返回值="""";
		if(所属栏目!=null&&所属栏目!=""""&&所属栏目.IndexOf('|')<1)
		{
			DataSet 内容栏目=(DataSet)Application[""UUN_UUN3G_NeiRongLanMu""];
			for(int i=0;i<内容栏目.Tables[0].Rows.Count;i++)
			{
				DataRow 行=内容栏目.Tables[0].Rows[i];
				if(Convert.ToInt32(行[""ID""])==Convert.ToInt32(所属栏目))
					返回值=Convert.ToString(行[""栏目名称""]);
			}
		}
		return 返回值;
	}
	private String 生成余下全部地址()
	{
		return """";
	}
";
            String 返回值 = "";
            返回值 += @"	所属栏目=Request.QueryString[""ID""];
	关键字=Request.QueryString[""g""];
	一页显示记录数=获取一页显示记录数();
	栏目名称=获取栏目名称();
	跳页表单项=""<postfield name=\""ID\"" value=\""""+
		Server.HtmlEncode(所属栏目)+
		""\""/>""+
		""<postfield name=\""g\"" value=\""""+
		Server.HtmlEncode(关键字)+
		""\""/>""+
		""<postfield name=\""""+程序.设置[""标识名称""]+
		""\"" value=\""""+
		访问.用户[""标识""]+
		""\"" />"";
	_3G跳页表单项=""<input type=\""hidden\"" name=\""ID\"" value=\""""+
		Server.HtmlEncode(所属栏目)+
		""\"" />""+
		""<input type=\""hidden\"" name=\""g\"" value=\""""+
		Server.HtmlEncode(关键字)+
		""\"" />""+
		""<input type=\""hidden\"" name=\""""+程序.设置[""标识名称""]+
		""\"" value=\""""+
		访问.用户[""标识""]+
		""\"" />"";
";
            返回值 += 生成音乐列表条件(true, "");
            返回值 += "\t\t当前页=Convert.ToInt32(Request.QueryString[\"page\"]);\r\n";
            返回值 += "\t\t总记录数=Convert.ToInt32(数量语句.ExecuteScalar());\r\n";
            返回值 += "\t\t总页数=常用.计算总页数(总记录数,一页显示记录数);\r\n";
            返回值 += "\t\t当前页=常用.计算当前页(总页数,当前页);\r\n";

            return 返回值;
        }
        public String 编译公共标签(String 代码)
        {
            switch (代码)
            {
                case "栏目ID":
                    return "\t\t返回值.Append(Server.HtmlEncode(所属栏目));\r\n";
                case "栏目名称":
                    return "\t\t返回值.Append(Server.HtmlEncode(栏目名称));\r\n";
                case "当前页":
                    return "\t\t返回值.Append(当前页.ToString());\r\n";
                case "总页数":
                    return "\t\t返回值.Append(总页数.ToString());\r\n";
                case "总记录数":
                    return "\t\t返回值.Append(总记录数.ToString());\r\n";
                case "栏目内搜索":
                    return @"
		if(栏目名称!="""")
		{
";
                case "/栏目内搜索":
                    return @"
		}
";
                case "非栏目内搜索":
                    return @"
		if(栏目名称=="""")
		{
";
                case "/非栏目内搜索":
                    return @"
		}
";
                case "搜索结果":
                    return @"
		if(关键字!=null&&关键字!="""")
		{
";
                case "/搜索结果":
                    return @"
		}
";
                case "非搜索结果":
                    return @"
		if(关键字==null||关键字=="""")
		{
";
                case "/非搜索结果":
                    return @"
		}
";
                default:
                    return "";
            }
        }

        public String 编译模板方法(String 方法名称, String[] 属性数组)
        {
            switch (方法名称)
            {
                case "_音乐列表":
                    return 音乐列表(属性数组[0], 属性数组[1],
                        属性数组[2],
                        Convert.ToInt32(属性数组[3]),
                        属性数组[4]);
                case "列表分页":
                    return 列表分页(Convert.ToInt32(属性数组[0]),
                        属性数组[1]);
                case "分页设置":
                    return 分页设置(Convert.ToInt32(属性数组[0]));
                default:
                    return "";
            }
        }

        private String 生成音乐列表条件(bool 是否数量, String 查询字段)
        {
            String 返回值 = "";
            String 语句名称 = 是否数量 ? "数量语句" : "语句";
            if (是否数量)
            {
                返回值 += "\t\t查询条件+=\" WHERE [是否审核]=@是否审核 AND [是否删除]=@是否删除\";\r\n";
                返回值 += @"
		if(关键字!=""""&&关键字!=null)
			查询条件+="" AND (""+常用.SQL_搜索条件(关键字,""标题,歌手名称,所属专辑"")+"")"";
";
                返回值 += "\t\tif(所属栏目!=null&&所属栏目!=\"\"&&所属栏目!=\"0\")\r\n";
                返回值 += "\t\t{\r\n";
                返回值 += "\t\t\t查询条件+=\" AND (\";\r\n";
                返回值 += "\t\t\tString[] IDS=所属栏目.Split(new char[] { '|' }, StringSplitOptions.RemoveEmptyEntries);\r\n";
                返回值 += "\t\t\tfor(int i=0;i<IDS.Length;i++)\r\n";
                返回值 += "\t\t\t\tif(i==0)\r\n";
                返回值 += "\t\t\t\t\t查询条件+=\"[所属栏目]=\"+Convert.ToInt32(IDS[i]);\r\n";
                返回值 += "\t\t\t\telse\r\n";
                返回值 += "\t\t\t\t\t查询条件+=\" OR [所属栏目]=\"+Convert.ToInt32(IDS[i]);\r\n";
                返回值 += "\t\t\t查询条件+=\")\";\r\n";
                返回值 += "\t\t}\r\n";
            }
            返回值 += "\t\tString " + 语句名称 + "SQL=\"SELECT " + (是否数量 ? "COUNT(ID)" : 查询字段) + " FROM [\"+程序.数据表前缀+\"内容_音乐_音乐]\"+查询条件;\r\n";

            if (!是否数量)
                返回值 += @"
		" + 语句名称 + @"SQL+="" ORDER BY [ID] DESC"";
";
            返回值 += "\t\tSqlCommand " + 语句名称 + "=new SqlCommand(" + 语句名称 + "SQL,访问.连接);\r\n";
            返回值 += "\t\t" + 语句名称 + ".Parameters.Add(\"@是否审核\",SqlDbType.Bit).Value=false;\r\n";
            返回值 += "\t\t" + 语句名称 + ".Parameters.Add(\"@是否删除\",SqlDbType.Bit).Value=false;\r\n";
            return 返回值;
        }

        private String 音乐列表(String 空记录代码, String 格式, String 交替格式, int 字数, String 时间格式)
        {
            String 随机值 = 常用.随机字符(8);

            Hashtable 必须字段 = new Hashtable();
            必须字段.Add("序号", "");
            必须字段.Add("标题", "标题,标题样式_粗体,标题样式_斜体,标题样式_删除线,标题样式_颜色");
            必须字段.Add("栏目名称", "所属栏目");
            必须字段.Add("音乐地址", "ID,所属栏目,外部链接");
            必须字段.Add("栏目地址", "所属栏目");
            必须字段.Add("评论地址", "ID,所属栏目");
            必须字段.Add("歌手链接", "歌手名称");
            必须字段.Add("专辑链接", "所属专辑");
            Hashtable 字段代码 = new Hashtable();
            字段代码.Add("序号", "(当前页-1)*一页显示记录数+i+1");
            字段代码.Add("标题", "常用.强调关键字(常用.标题样式(行[\"标题\"].ToString(),Convert.ToBoolean(行[\"标题样式_粗体\"]),Convert.ToBoolean(行[\"标题样式_斜体\"]),Convert.ToBoolean(行[\"标题样式_删除线\"]),Convert.ToString(行[\"标题样式_颜色\"])," + Convert.ToInt32(字数) + "),关键字," + (!编译器.是否WML网页).ToString().ToLower() + ")");
            字段代码.Add("音乐地址", @"行[""外部链接""].ToString()!=""""?Server.HtmlEncode(常用.处理地址(行[""外部链接""].ToString(),访问.用户[""外部链接""].ToString())):Server.HtmlEncode(常用.处理地址(程序.安装位置+""" + (编译器.是否WML网页 ? "" : "3G_") + @"Content.aspx?CID=""+行[""所属栏目""]+""&ID=""+行[""ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("栏目地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""" + (编译器.是否WML网页 ? "" : "3G_") + @"Column.aspx?ID=""+行[""所属栏目""],访问.用户[""标识""].ToString()))");
            字段代码.Add("评论地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""" + (编译器.是否WML网页 ? "" : "3G_") + @"Comment.aspx?CID=""+行[""所属栏目""]+""&ID=""+行[""ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("歌手链接", @"Convert.ToString(行[""歌手名称""].ToString())==""""?""未知"":""<a href=\""""+Server.HtmlEncode(常用.处理地址(程序.安装位置+""" + (编译器.是否WML网页 ? "" : "3G_") + @"Singer.aspx?g=""+Server.UrlEncode(行[""歌手名称""].ToString()),访问.用户[""标识""].ToString()))+""\"">""+常用.强调关键字(Server.HtmlEncode(行[""歌手名称""].ToString()),关键字," + (!编译器.是否WML网页).ToString().ToLower() + @")+""</a>""");
            字段代码.Add("专辑链接", @"Convert.ToString(行[""所属专辑""].ToString())==""""?""未知"":""<a href=\""""+Server.HtmlEncode(常用.处理地址(程序.安装位置+""" + (编译器.是否WML网页 ? "" : "3G_") + @"Album.aspx?g=""+Server.UrlEncode(行[""所属专辑""].ToString()),访问.用户[""标识""].ToString()))+""\"">""+常用.强调关键字(Server.HtmlEncode(行[""所属专辑""].ToString()),关键字," + (!编译器.是否WML网页).ToString().ToLower() + @")+""</a>""");
            字段代码.Add("歌手名称", @"Server.HtmlEncode(行[""歌手名称""].ToString())");
            字段代码.Add("所属专辑", @"Server.HtmlEncode(行[""所属专辑""].ToString())");
            字段代码.Add("栏目名称", @"Server.HtmlEncode(常用.获取栏目名称(Convert.ToInt32(行[""所属栏目""])))");
            字段代码.Add("发布时间", @"Convert.ToDateTime(行[""发布时间""]).ToString(""" + 时间格式 + "\")");
            字段代码.Add("最后评论时间", @"Convert.ToDateTime(行[""最后评论时间""]).ToString(""" + 时间格式 + "\")");
            字段代码.Add("最后收藏时间", @"Convert.ToDateTime(行[""最后收藏时间""]).ToString(""" + 时间格式 + "\")");

            String 查询字段, 行代码;
            查询字段 = 编译器.生成查询字段(格式, 交替格式, 必须字段, 字段代码, out 行代码);

            编译器.方法库 += "\tprivate void 音乐列表" + 随机值 + "()\r\n";
            编译器.方法库 += "\t{\r\n";
            编译器.方法库 += "\t\tif(总记录数<1)\r\n";
            编译器.方法库 += "\t\t\t返回值.Append(@\"" + 空记录代码.Replace("\"", "\"\"") + "\");\r\n";
            编译器.方法库 += 生成音乐列表条件(false, 查询字段);
            编译器.方法库 += 生成查询结果列表(行代码);

            return "\t\t音乐列表" + 随机值 + "();\r\n";
        }
        private String 生成查询结果列表(String 行代码)
        {
            String 返回值 = "";
            返回值 += "\t\tDataSet 数据=new DataSet();\r\n";
            返回值 += "\t\tSqlDataAdapter 填充=new SqlDataAdapter(语句);\r\n";
            返回值 += "\t\t填充.Fill(数据,(当前页-1)*一页显示记录数,一页显示记录数,\"表\");\r\n";
            返回值 += "\t\tfor(int i=0;i<数据.Tables[0].Rows.Count;i++)\r\n";
            返回值 += "\t\t{\r\n";
            返回值 += 行代码;
            返回值 += "\t\t}\r\n";
            返回值 += "\t\t}\r\n";
            return 返回值;
        }

        private String 列表分页(int ID, String 无分页代码)
        {
            return 编译器.编译内容分页(
                (编译器.文件名称.StartsWith(程序.安装位置 + "club/", StringComparison.OrdinalIgnoreCase) ? "Club" : "Content"),
                "Page", ID, 无分页代码);
        }

        private String 分页设置(int 一页显示记录数)
        {
            if (一页显示记录数 > 0)
                this.一页显示记录数 = 一页显示记录数;
            return "";
        }

        public String 结束执行代码()
        {
            编译器.方法库 += @"	private int 获取一页显示记录数()
	{
";
            if (一页显示记录数 == 0)
                编译器.方法库 += "\t\treturn 访问.获取一页显示记录数();\r\n";
            else
                编译器.方法库 += "\t\treturn " + 一页显示记录数 + ";\r\n";
            编译器.方法库 += @"
	}
";
            return "";
        }
    }
}